/***************************************************************************
 *   Copyright (C) 2007-2008 by Peter Semiletov                            *
 *   peter.semiletov@gmail.com                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QApplication>


#include "singleapplication.h"
#include "systemsemaphore.h"


#include "rvln.h"

#ifdef Q_OS_WIN
#define _WIN32_WINNT 0x0501
#include <qt_windows.h>
#endif


int main(int argc, char *argv[])
{
  Q_INIT_RESOURCE (application);
  qApp->setApplicationName("TEA");

#ifdef Q_OS_WIN
        AllowSetForegroundWindow(ASFW_ANY);
#endif

  CApplication app (argc, argv);
  app.connect(&app, SIGNAL(lastWindowClosed()), &app, SLOT(quit()));

#ifdef Q_OS_WIN
  QDir::setCurrent(app.applicationDirPath());
#endif


  SingleApplication instance("Teainstance", &app);
  if (instance.isRunning())
    {
     for (int i = 1; i < argc; ++i)
         instance.sendMessage(argv[i]);

     return 0;
    }


   rvln *mw = new rvln();
   QObject::connect(&instance, SIGNAL(messageReceived(const QString&)),
                    mw, SLOT(handleMessage(const QString&)));


   mw->show();


   for (int i = 1; i < argc; ++i)
       mw->handleMessage(argv[i]);



   return app.exec();
}
