/*******************************************************************************
SingleApplication provides a way to detect a running instance.
Copyright (C) 2008  Ritt K.
*   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef SYSTEMSEMAPHORE_P_H
#define SYSTEMSEMAPHORE_P_H

#include "systemsemaphore.h"

#ifdef Q_OS_WIN
#include <qt_windows.h>
#else
#include <sys/sem.h>
#endif

class SystemSemaphorePrivate
{
public:
	SystemSemaphorePrivate();

	QString makeKeyFileName();

#ifdef Q_OS_WIN
	HANDLE handle(SystemSemaphore::AccessMode mode = SystemSemaphore::Open);
#else
	key_t handle(SystemSemaphore::AccessMode mode = SystemSemaphore::Open);
#endif
	void setErrorString(const QString& function);
	void cleanHandle();
	bool modifySemaphore(int count, int timeout = -1);

	QString key;
	QString fileName;
	int initialValue;
#ifdef Q_OS_WIN
	HANDLE semaphore;
	HANDLE semaphoreLock;
#else
	int semaphore;
	bool createdFile;
	bool createdSemaphore;
	key_t unix_key;
#endif

	QString errorString;
	SystemSemaphore::SystemSemaphoreError error;
};

#endif // SYSTEMSEMAPHORE_P_H
